<?php
/**
 * @package		WE Domain Checker (based on SecureDomainAPI) v3.1
 * @author		Web-expert.gr http://www.web-expert.gr
 * @copyright	Copyright (c) 2010 - 2012 Web-expert.gr . All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */
if(!count($_POST) || !(int)$_POST["moduleid"]) exit('Error with Request');
$format=!isset($_POST['format'])?'html':strtolower($_POST['format']);
if($format=='json')
	@header('Content-Type: application/json; charset=utf-8');
elseif($format=='plain')
	@header('Content-Type: text/plain; charset=utf-8');
else
	@header('Content-Type: text/html; charset=utf-8');

define( '_JEXEC', 1 );
define( 'DS', DIRECTORY_SEPARATOR );
define('JPATH_BASE', str_replace(DS.'modules'.DS.'mod_we_domainchecker'.DS.'domaincheck','',dirname(__FILE__)) );
require_once( JPATH_BASE .DS.'includes'.DS.'defines.php' );
require_once( JPATH_BASE .DS.'includes'.DS.'framework.php' );
$mainframe =JFactory::getApplication('site');
$mainframe->initialise();

//error_reporting(1);
//ini_set('display_errors',1);

$langTag = version_compare(JVERSION,'2.5.0','ge')?$mainframe->input->getCMD('lang','en-GB'):JRequest::getVar('lang','en-GB');
$language =JFactory::getLanguage();
$language->setLanguage($langTag);
$language->load('mod_we_domainchecker',JPATH_SITE,$langTag);
jimport( 'joomla.application.module.helper' );

$moduleid = version_compare(JVERSION,'2.5.0','ge')?$mainframe->input->getInt('moduleid',0):JRequest::getInt('moduleid',0);
$db = JFactory::getDbo();
$query = 'SELECT m.id, m.title, m.module, m.position, m.content, m.showtitle, m.params, mm.menuid FROM #__modules AS m LEFT JOIN #__modules_menu AS mm ON mm.moduleid = m.id WHERE m.module="mod_we_domainchecker" AND m.published = 1 AND m.id='.$moduleid;
$db->setQuery($query);
$module = $db->loadObject();

$params=class_exists('JParameter') ? new JParameter($module->params) : new JRegistry($module->params);
$domainApiURL=rtrim(trim($params->get('domainapiurl', "")),'/');

if(empty($domainApiURL))
{
	if($format=='json') 
		echo json_encode(array('error'=>'EMPTY DOMAIN API URL'));
	else
		echo 'Error: EMPTY DOMAIN API URL';
	exit;
}

//Prepare Params
$httpParams=array('domainapi'=>'checkdomain','key'=>$params->get('apikey',''),'domain'=>$_POST["domain"],'format'=>'json');
if(isset($_POST["tlds"]) && count($_POST["tlds"])) $httpParams['tlds']=$_POST["tlds"];

//Make Request
$stream=stream_context_create(array(
	'ssl' => array(
        'verify_peer' => false,
        'verify_peer_name' => false,
        'allow_self_signed' => true
    ),
	'http' => array(
		'timeout'=>20,
		'ignore_errors' => 1,
		'max_redirects'=>1,
		'user_agent' => $_SERVER['HTTP_USER_AGENT'],
	),
));

$dataJSON=file_get_contents($domainApiURL.'/index.php?'.http_build_query($httpParams),false,$stream); //get Data

if($format=='json')
{
	if($dataJSON===false) $dataJSON=json_encode(array('error'=>error_get_last()));
	echo $dataJSON;
}
else
{
	if($dataJSON!==false)
	{
		$data=@json_decode($dataJSON,true);
		if($data!==NULL)
		{
			$layout = version_compare(JVERSION,'2.5.0','ge')?$mainframe->input->getCMD('layout','Default'):JRequest::getVar('layout','Default');
			require(JModuleHelper::getLayoutPath('mod_we_domainchecker',$params->get('layout',$layout).DS.'result'));
		}
		else
		{
			$httpParams['key']='hidden';
			echo 'ERROR with API <pre>'.$domainApiURL.'/index.php?'.http_build_query($httpParams).'</pre>';
			if((int)$params->get('degug',0)) echo '<pre><code>'.$data.'</code></pre>';
		}
	}
	else
	{
		echo 'ERROR:'.print_r(error_get_last(),true);
	}
}
$mainframe->close();