<?php
/**
 * @package		WE Domain Checker (based on SecureDomainAPI) v3.1
 * @author		Web-expert.gr http://www.web-expert.gr
 * @copyright	Copyright (c) 2010 - 2012 Web-expert.gr . All rights reserved.
 * @license		GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
 */
defined('_JEXEC') or die('Restricted access'); // no direct access
if(version_compare(JVERSION, '3.5.0', 'ge'))
{
	jimport('joomla.form.formfield');
	class WEElement extends JFormField
    {
        function getInput()
        {
            return $this->fetchElement($this->name, $this->value, $this->element, $this->options['control']);
        }

        function getLabel()
        {
            if (method_exists($this, 'fetchTooltip'))
            {
                return $this->fetchTooltip($this->element['label'], $this->description, $this->element, $this->options['control'], $this->element['name'] = '');
            }
            else
            {
                return parent::getLabel();
            }
        }

        function render($layoutId, $data = array())
        {
            return $this->getInput();
        }
    }
	
}
elseif(version_compare(JVERSION,'1.6.0','ge'))
{
	jimport('joomla.form.formfield');
	class WEElement extends JFormField
    {
        function getInput()
        {
            return $this->fetchElement($this->name, $this->value, $this->element, $this->options['control']);
        }

        function getLabel()
        {
            if (method_exists($this, 'fetchTooltip'))
            {
                return $this->fetchTooltip($this->element['label'], $this->description, $this->element, $this->options['control'], $this->element['name'] = '');
            }
            else
            {
                return parent::getLabel();
            }
        }

        function render()
        {
            return $this->getInput();
        }
    }
}else{
	jimport('joomla.html.parameter.element');
    class WEElement extends JElement{}
}

class WeTemplate extends WEElement {
		
	function fetchElement($name, $value, &$node, $control_name){
		$isNewJoomla=version_compare(JVERSION,'1.6.0','ge');
		
		jimport('joomla.filesystem.folder');
		
		$fieldName = ($isNewJoomla)? $name : $control_name.'['.$name.']';
		$modulePath = JPATH_SITE.DIRECTORY_SEPARATOR.'modules'.DIRECTORY_SEPARATOR.'mod_we_domainchecker'.DIRECTORY_SEPARATOR.'tmpl';
		$tmplFolders = JFolder::folders($modulePath);
				
		$db = JFactory::getDBO();
		$query = "SELECT template FROM #__templates_menu WHERE client_id = 0 AND menuid = 0";
		if($isNewJoomla) $query = "SELECT template FROM #__template_styles WHERE client_id = 0 AND home = 1";
		$db->setQuery($query);
		$defaultemplate = $db->loadResult();

		$templatePath = JPATH_SITE.DIRECTORY_SEPARATOR.'templates'.DIRECTORY_SEPARATOR.$defaultemplate.DIRECTORY_SEPARATOR.'html'.DIRECTORY_SEPARATOR.'mod_we_domainchecker';

		if (JFolder::exists($templatePath)){
			$templateFolders = JFolder::folders($templatePath);
			$folders = @array_merge($templateFolders, $tmplFolders);
			$folders = @array_unique($folders);
		} else {
			$folders = $tmplFolders;
		}
				
		$exclude = 'default';
		$options = array ();
		foreach ($folders as $folder) {
			if (preg_match(chr(1).$exclude.chr(1), $folder)) continue ;
			$options[] = JHTML::_('select.option', $folder, $folder);
		}
		array_unshift($options, JHTML::_('select.option', '', '-- '.JText::_('Use Default').' --'));
		return JHTML::_('select.genericlist', $options, $fieldName, 'class="inputbox"', 'value', 'text', $value, $control_name.$name);
	}
}

class JFormFieldTemplate extends WeTemplate {
	var	$type = 'template';
}
class JElementTemplate extends WeTemplate {
	var	$_name = 'template';
}
	